# hey Emacs, its -*- mode: rpm-spec; coding: cyrillic-koi8r; -*-

Name: mdadm
Version: 2.6.3
Release: alt1

Summary: A tool for managing Soft RAID under Linux
License: GPL
Group: System/Configuration/Hardware
Url: http://cgi.cse.unsw.edu.au/~neilb/%name

Source0: http://www.kernel.org/pub/linux/utils/raid/%name/%name-%version.tar.bz2
Source1: %name.init
Source2: raidtabtomdadm.sh
Source3: rc.sysinit-mdassemble.patch
Source4: %name.conf
Patch0: %name-2.5-alt-no_strict_aliasing.patch
Patch1: %name-2.5-alt-sha1sources.patch
Patch2: %name-2.5.5-alt-asprintf.patch
Patch3: %name-2.6.2-alt-nowarn.patch

%def_without udev
%def_with   dietlibc

%if_without dietlibc
%define mdassemble_binary mdassemble.static

%else
%define mdassemble_binary mdassemble

BuildPreReq: dietlibc
# ..requires  on  x86_64 >= 0.30-alt1.1
# ..requires with gcc4.1 >= 0.30-alt2 (or building with -fno-stack-protector)

%endif

# Automatically added by buildreq on Mon Mar 07 2005
BuildRequires: groff-base

Summary(ru_RU.KOI8-R):      (Software RAID)

%description
%name is a program that can be used to create, manage, and monitor
Linux MD (Software RAID) devices.

As such is provides similar functionality to the raidtools packages.
The particular differences to raidtools is that mdadm is a single
program, and it can perform (almost) all functions without
a configuration file (that a config file can be used to help
with some common tasks).

Look also for mdmpd, monitoring daemon for resetting kernel state
of failed, but restored devices.

%description -l ru_RU.KOI8-R
%name    ,   
    (Software RAID), 
     "md" (multiple devices).

%name      raidtools.

   raidtools, %name    
       ,
    .

   %name     mdmpd,
        
       .

%prep
%setup -q
%patch0 -p1
#patch1 -p1
%patch2 -p1
%patch3 -p1
%__cp -au %SOURCE2 %SOURCE3 .

%build
%make_build %mdassemble_binary CXFLAGS="%optflags" MDASSEMBLE_AUTO=1 SYSCONFDIR="%_sysconfdir"
%make_build CXFLAGS="%optflags" SYSCONFDIR="%_sysconfdir"
bzip2 -9fk ChangeLog

%if_with udev
%define pre_udev_conf %_sysconfdir/%name.conf.before-udev
%endif

%install
%make_install install DESTDIR=%buildroot MANDIR=%_mandir BINDIR=/sbin
install -pD -m755 %SOURCE1 %buildroot%_initdir/%name
install -pD -m755 misc/syslog-events %buildroot/sbin/%name-syslog-events
install -pD -m755 %mdassemble_binary %buildroot/sbin/mdassemble
install -pD -m600 %SOURCE4 %buildroot%_sysconfdir/%name.conf
install -pD -m644 mdassemble.8 %buildroot%_man8dir/mdassemble.8
%if_with udev
%__touch %buildroot%pre_udev_conf
%endif

%post -f raidtabtomdadm.sh
%post_service %name

%preun
%preun_service %name

%triggerin -- udev
[ $1 = 1 -a $2 = 1 ] || exit 0
echo >&2 "\
IMPORTANT NOTE: udev service may change device file names.
--------------  It's recommended to diagnose (or remove, if possibly)
                all 'DEVICE' lines and 'devices=' options in
		%_sysconfdir/%name.conf and call 'service mdadm restart' command."

%files
/sbin/md*
#_sbindir/md*
%config(noreplace,missingok) %_sysconfdir/%name.conf
%if_with udev
%ghost %config(noreplace,missingok) %noverify %pre_udev_conf
%endif
%_mandir/man?/md*
%_initdir/%name
%doc TODO ChangeLog.bz2 %name.conf-example ANNOUNCE-%version

%changelog
* Wed Aug 22 2007 Ilya Evseev <evseev@altlinux.ru> 2.6.3-alt1
- updated to new version 2.6.3

* Tue May 22 2007 Ilya Evseev <evseev@altlinux.ru> 2.6.2-alt1
- updated to new version 2.6.2, fix patch #3

* Mon Apr 16 2007 Dmitry V. Levin <ldv@altlinux.org> 2.6.1-alt3.1
- mdadm.init: Fixed typo introduced in 2.6.1-alt3 release.
- %%triggerun: Removed.
- %%triggerin: Do not spam on every package update.

* Sun Apr 15 2007 Ilya Evseev <evseev@altlinux.ru> 2.6.1-alt3
- bugfixes:
   + 11021: shutdown previous versions of mdadm at /usr/sbin on RPM upgrade
   + 11431: dont start service when no records in /proc/mdstat

* Sat Mar  3 2007 Ilya Evseev <evseev@altlinux.ru> 2.6.1-alt2
- fixed installation path for mdadm-syslog-events

* Sat Mar  3 2007 Ilya Evseev <evseev@altlinux.ru> 2.6.1-alt1
- updated to version 2.6.1, simplify patch #3
- bugfixes:
   + 10357 (mdassemble crashes because dietlibc < 0.30-alt2
            with gcc4.1 needs -fno-stack-protector)
   + 10727 (missing mdassemble.8 manpage)
   + 10782 (strange events in mdmonitor - possibly fixed in upstream?)
   + 10909 (change 740 permissions to 755)
   + 10910 (support condstop in service script)
   + 10915 (move binaries from /usr/sbin to /sbin)

* Wed Jan 24 2007 Ilya Evseev <evseev@altlinux.ru> 2.6-alt2
- fixed x86_64 problems

* Mon Jan 22 2007 Ilya Evseev <evseev@altlinux.ru> 2.6-alt1
- updated to new version 2.6

* Wed Nov 22 2006 Ilya Evseev <evseev@altlinux.ru> 2.5.6-alt1
- updated to new version 2.5.6

* Fri Oct 27 2006 Ilya Evseev <evseev@altlinux.ru> 2.5.5-alt1
- updated to new version 2.5.5
- patch for ignoring asprintf result (yes, I know that's dirty..)

* Sat Sep  2 2006 Ilya Evseev <evseev@altlinux.ru> 2.5.3-alt2
- fixed dietlibc-related problems (#9939) on x86_64
- added optional disabling of dietlibc usage

* Tue Aug  8 2006 Ilya Evseev <evseev@altlinux.ru> 2.5.3-alt1
- updated to new version 2.5.3

* Tue Jul 25 2006 Ilya Evseev <evseev@altlinux.ru> 2.5.2-alt1
- updated to new version 2.5.2

* Thu Jun 22 2006 Ilya Evseev <evseev@altlinux.ru> 2.5.1-alt1
- updated to new version 2.5.1
- patch #1 is no more needed because the same thing is now in the upstream
- fixup command line arguments for mdassemble build

* Mon May 29 2006 Ilya Evseev <evseev@altlinux.ru> 2.5-alt2
- added patch #1 for omitting openssl dependency
- little description changes

* Fri May 26 2006 Ilya Evseev <evseev@altlinux.ru> 2.5-alt1
- updated to new version 2.5

* Fri Apr 28 2006 Ilya Evseev <evseev@altlinux.ru> 2.4.1-alt1
- updated to new version 2.4.1

* Thu Feb  9 2006 Ilya Evseev <evseev@altlinux.ru> 2.3.1-alt1
- updated to new version 2.3.1

* Fri Feb  3 2006 Ilya Evseev <evseev@altlinux.ru> 2.3-alt1
- updated to new version 2.3
- small specfile improvements:
   + mdadm stuff was compiled twice
   + more strict permissions for installed stuff

* Fri Oct 14 2005 Ilya Evseev <evseev@altlinux.ru> 2.1-alt3
- more once attempt to break new Sysiphus restrictions
  (halt on undefined macros even they are commented)

* Mon Oct 10 2005 Ilya Evseev <evseev@altlinux.ru> 2.1-alt2
- added workaround for new Sisyphus restriction:
  all macros should be defined even they are referenced in comments.

* Fri Sep 16 2005 Ilya Evseev <evseev@altlinux.ru> 2.1-alt1
- update to new version

* Wed Jul 27 2005 Ilya Evseev <evseev@altlinux.ru> 1.12.0-alt2
- bugfix #7087 (use grep instead of egrep in service script)
- watch udev (un)install and display warnings about changed devices naming
- created our own minimalistic configuration file for mdmonitor;
  however, it should be completely functional in most cases

* Wed Jul 13 2005 Michael Shigorin <mike@altlinux.org> 1.12.0-alt1
- 1.12.0
- removed peet@'s patch (fixed in 1.11.0)

* Thu May 12 2005 Peter V. Saveliev <peet@altlinux.ru> 1.10.0-rad1
- fixed device add

* Sun Apr 10 2005 Ilya Evseev <evseev@altlinux.ru> 1.10.0-alt1
- updated to 1.10.0, fixed segfault on 'mdadm -c partitions'
- changed project URL and source URL
- mdassemble cannot be disabled; it's installed to /sbin
- documentation: placed patch that should be applied to /etc/rc.d/rc.sysinit
  (see details on https://bugzilla.altlinux.org/show_bug.cgi?id=6322 and 6397)

* Mon Mar  8 2005 Ilya Evseev <evseev@altlinux.ru> 1.9.0-alt1
- 1.9.0
- specfile:
   + added russian summary and description,
   + changed source URL,
   + added mdmpd reference.
- taken from Mdk:
   + service init script,
   + raidtools conversion script,
   + diet libc bindings (may be turned off).

* Mon Jan 26 2004 Dmitry V. Levin <ldv@altlinux.org> 1.5.0-alt1
- Updated to 1.5.0.

* Thu Dec 18 2003 Dmitry V. Levin <ldv@altlinux.org> 1.4.0-alt1
- Updated to 1.4.0.
- Specfile cleanup.

* Tue May 20 2003 Alexander Bokovoy <ab@altlinux.ru> 1.2.0-alt1
- Initial build for ALT Linux Sisyphus

* Fri May 10 2002  <neilb@cse.unsw.edu.au>
- update to 1.0.0
- Set CXFLAGS instead of CFLAGS

* Sat Apr  6 2002  <neilb@cse.unsw.edu.au>
- change %install to use "make install"

* Fri Mar 15 2002  <gleblanc@localhost.localdomain>
- beautification
- made mdadm.conf non-replaceable config
- renamed Copyright to License in the header
- added missing license file
- used macros for file paths

* Fri Mar 15 2002 Luca Berra <bluca@comedia.it>
- Added Obsoletes: mdctl
- missingok for configfile

* Wed Mar 12 2002 NeilBrown <neilb@cse.unsw.edu.au>
- Add md.4 and mdadm.conf.5 man pages

* Fri Mar 08 2002		Chris Siebenmann <cks@cquest.utoronto.ca>
- builds properly as non-root.

* Fri Mar 08 2002 Derek Vadala <derek@cynicism.com>
- updated for 0.7, fixed /usr/share/doc and added manpage

* Tue Aug 07 2001 Danilo Godec <danci@agenda.si>
- initial RPM build

## EOF ##
